Package: MHD
Type: Package
Title: Metric Halfspace Depth
Version: 0.1.2
Date: 2024-01-22
Authors@R: person("Xiongtao", "Dai", email = "xiongtao.dai@hotmail.com", role = c("aut", "cre"))
Description: Metric halfspace depth for object data, generalizing Tukey's depth for Euclidean data. Implementing the method described in Dai and Lopez-Pintado (2022) <doi:10.1080/01621459.2021.2011298>.
License: GPL (>= 2)
Imports: Rcpp (>= 1.0.3), manifold, nloptr, distory, plyr
Suggests: foreach
LinkingTo: Rcpp
RoxygenNote: 7.3.0
Depends: R (>= 3.2.1)
Encoding: UTF-8
NeedsCompilation: yes
Packaged: 2024-01-23 16:17:10 UTC; xdai
Author: Xiongtao Dai [aut, cre]
Maintainer: Xiongtao Dai <xiongtao.dai@hotmail.com>
Repository: CRAN
Date/Publication: 2024-01-24 15:12:47 UTC
Built: R 4.4.0; x86_64-apple-darwin19.6.0; 2024-05-05 19:12:36 UTC; unix

library(testthat)
library(ddalpha)
test_that('Different MHD implementations are the same. They are closed to the exact depth', {

  n <- 50
  xInd <- seq_len(n)
  set.seed(1)
  for (p in 2:3) {
    data <- cbind(
      MASS::mvrnorm(n, rep(0, p), 
              diag(seq_len(p), nrow=p)),
      rexp(n))

    depths <- ddalpha::depth.halfspace(data, data, exact=TRUE)

    distM <- as.matrix(dist(data))
    dataInd <- seq_len(nrow(distM))
    # myDepth <- MHalfDepth(distM, xInd, dataInd)
    # myDepth2 <- MHD2(distM, xInd, dataInd)
    myDepth3 <- MHD_cpp(distM)
    
    expect_equal(cor(depths, myDepth3), 1, scale=1, tol=0.15)
    # expect_equal(myDepth, myDepth3)
    # expect_equal(myDepth2, myDepth3)
  }
})


test_that('When there are a lot of anchor points, the result is closer to the true Tukeys depth', {
  
  n <- 20
  xInd <- seq_len(n)
  set.seed(1)
  p <- 2
  data <- MASS::mvrnorm(n, rep(0, p), 
            diag(seq_len(p), nrow=p))

  depths <- ddalpha::depth.halfspace(data, data, exact=TRUE)

  grid <- seq(-5, 5, length.out=30)
  anc <- as.matrix(expand.grid(grid, grid))
  # nAnc <- nrow(anc)
  # anc <- data
  distM <- as.matrix(PairwiseDistance(data, Lp))
  distM2 <- PairwiseDistance2(data, anc, Lp, p=2)
  
  myDepth <- MHD_cpp(distM)
  myDepth2 <- MHD_cpp(distM2)
  expect_true(Lp(depths, myDepth) >= Lp(depths, myDepth2))
  expect_equal(depths, myDepth2)
  
})


test_that('The implementation with user-specified eval points work', {

  n <- 50
  set.seed(1)
  p <- 2
  data <- MASS::mvrnorm(n, rep(0, p), 
            diag(seq_len(p), nrow=p))

  # depths <- ddalpha::depth.halfspace(data, data, exact=TRUE)

  distM <- as.matrix(dist(data))
  myDepth_all <- MHD_cpp(distM)

  xInd <- 1:3
  ancX <- distM[, xInd, drop=FALSE]
  myDepth <- MHD2_cpp(distM, ancX)
  expect_equal(myDepth_all[xInd], myDepth)

  x <- matrix(c(0, 0), 1, p)
  ancX <- PairwiseDistance2(data, x, Lp)
  myDepth0 <- MHD2_cpp(distM, ancX)
  expect_equal(myDepth0, 0.5, scale=1, tolerance=0.1)
})


test_that('MHD_cpp and MHD2_cpp agrees', {
  
  n <- 50
  set.seed(1)
  p <- 2
  data <- MASS::mvrnorm(n, rep(0, p), 
            diag(seq_len(p), nrow=p))

  distM <- as.matrix(dist(data))
  myDepth1 <- MHD_cpp(distM)
  myDepth2 <- MHD2_cpp(distM, distM)
  expect_equal(myDepth1, myDepth2)

  grid <- seq(-5, 5, length.out=30)
  anc <- as.matrix(expand.grid(grid, grid))
  distM2 <- PairwiseDistance2(data, anc, Lp, p=2)
  myDepth3 <- MHD_cpp(distM2)
  myDepth4 <- MHD2_cpp(distM2, t(distM2))
  expect_equal(myDepth3, myDepth4)

})


test_that('MHD true depth is working', {

  n <- 50
  xInd <- seq_len(n)
  set.seed(1)
  p <- 3
  mfdName <- 'AffInv'

  for (p in 2:4) {
  for (mfdName in c('Euclidean', 'Sphere', 'AffInv')) {
    mfd <- manifold::createM(mfdName)
    dInt <- manifold::calcIntDim(mfd, geomPar=p)

    data <- t(manifold::rmfd(mfd, n, dInt))
    anchors <- t(manifold::rmfd(mfd, 3 * n, dInt))

    Dist <- function(a, B) {
      manifold::distance(mfd, a, t(B))
    }
    # profvis::profvis({
    datAnc <- PairwiseDistance2(data, anchors, Dist)
    # })
    ancX <- t(datAnc)

    depthOnly <- MHD2_cpp(datAnc, ancX)

    # print(system.time({
    depthObj <- MHD(mfd, data, anchors)
    # }))

    expect_equal(depthOnly, depthObj$depthSamp)

    # Out-of-sample deepest depth is larger than the in-sample version
    expect_true(depthObj$depthDeepest >= max(depthObj$depthSamp))

    # TODO: test API of nloptr etc
  }
  }
})


test_that('MHD jiggle= and XEval= are working', {

  n <- 50
  xInd <- seq_len(n)
  set.seed(1)
  p <- 2
  mfdName <- 'AffInv'

  mfd <- manifold::createM(mfdName)
  dInt <- manifold::calcIntDim(mfd, geomPar=p)

  data <- t(manifold::rmfd(mfd, n, dInt))
  anchors <- t(manifold::rmfd(mfd, n, dInt))

  Dist <- function(a, B) {
    manifold::distance(mfd, a, t(B))
  }

  o <- manifold::origin(mfd, dInt)

  # print(system.time({
  obj <- MHD(mfd, data, anchors, XEval=t(o))
  # }))
  # print(system.time({
  objJig <- MHD(mfd, data, anchors, jiggle=2, XEval=t(o))
  # }))

  expect_true(all(obj$depthSamp >= objJig$depthSamp))

  expect_true(all(obj$depthX >= objJig$depthX))

})


test_that('MHD_tree works', {

  dat <- kdetrees::apicomplexa
  res0 <- MHD_tree(dat, jiggle=0)
  res2 <- MHD_tree(dat, jiggle=2)

  expect_true(all(res0$depthSamp >= res2$depthSamp))
})

test_that('L1Depth is correct', {

  n <- 50
  xInd <- seq_len(n)
  set.seed(1)
  p <- 2
  for (p in 2:3) {
    data <- cbind(
      MASS::mvrnorm(n, rep(0, p), 
              diag(seq_len(p), nrow=p)),
      rexp(n))

    distM <- as.matrix(dist(data))

    a <- LpAve(distM)
    expect_equal(a, colMeans(distM))
    expect_equal(LpAve(distM, p=2), colMeans(distM^2)^(1/2))

    ind <- 1:10
    dataX <- distM[, ind, drop=FALSE]
    expect_equal(LpAve(dataX), a[ind])
  }
})

library(testthat)

test_that('Optimization for the deepest point', {

  skip('slow')
  library(tidyverse)

  # This example is generated from test_MHD.R with n=50, p=4, mfdName='AffInv', seed=1, tol=1e-14
  load(system.file('testdata', 'SPD4.RData', package='MHD'))
  attach(testDat)
  basis <- manifold::basisTan(mfd, theta0)
  Dist <- function(x, Y) {
    manifold::distance(mfd, x, t(Y))
  }

  F <- function(v0) {
    v <- basis %*% as.matrix(v0)
    expv <- t(rieExp(mfd, theta0, v))
    D <- PairwiseDistance2(anchors, expv, Dist)
    ind <- outer(D, D, '-') <= 0 + tol
    vec <- prop[ind]
    min(vec)
  }

  p <- sqrt(length(theta0))
  origPar <- crossprod(basis, rieLog(mfd, theta0, c(diag(nrow=p))))
  -F(origPar)

  x0 <- rep(0, ncol(basis))
  lb <- rep(-1, length(x0))
  ub <- rep(1, length(x0))
  # optRes <- optim(origPar, F, method='Nelder-Mead', control=list(fnscale=-1))

  globalAlgoList <- c('NLOPT_GN_DIRECT', 
                      'NLOPT_GN_CRS2_LM', 
                      'NLOPT_GN_MLSL_LDS', 
                      'NLOPT_GN_ISRES', 
                      'NLOPT_GN_ESCH')
  local_opts <- list(algorithm='NLOPT_LN_SBPLX', xtol_rel=1e-7)
  otherOpt <- list(maxeval=1000, 
                   print_level=0)
  gloOpt <- map(globalAlgoList, function(algo) {
                     opt <- c(list(algorithm=algo), otherOpt)
                     if (algo %in% c('NLOPT_GN_MLSL_LDS')) {
                       opt <- c(opt, list(local_opts=local_opts))
                     }
                     opt
                   })

  localAlgoList <- c('NLOPT_LN_COBYLA',
                     'NLOPT_LN_PRAXIS',
                     'NLOPT_LN_NELDERMEAD',
                     'NLOPT_LN_SBPLX')

  stopCrit <- c(xtol_abs=1e-4)
  otherOptLoc <- list(maxeval=100, 
                      print_level=0)
  locOpt <- map(localAlgoList, function(algo) {
                     opt <- c(list(algorithm=algo), otherOptLoc)
                     opt
                   })


  resGlo <- map(gloOpt, function(opt) {
                     nloptr::nloptr(x0, function(x) -F(x), lb=lb, ub=ub, opts=opt)
                   })

  a <- tibble(algoGlo=globalAlgoList, resGlo=resGlo) %>% 
    mutate(resLoc = map(resGlo, function(res) {
      # Take each global result, and further polish it with each of the local methods
      
      resLoc <- map(locOpt, function(loc) {
        nloptr::nloptr(res$solution, function(x) -F(x), lb=lb, ub=ub, opts=loc)
      })
      tibble(algoLoc=localAlgoList, resLoc=resLoc)
    })) 
  resAll <- a %>% 
    unnest(resLoc) %>% 
    mutate(objective = map_dbl(resLoc, `[[`, 'objective'),
           solution = map(resLoc, `[[`, 'solution'))

})

library(testthat)
library(foreach)
library(doParallel)
registerDoParallel(cores=2)

test_that('PairwiseDistance is right', {

  n <- 50
  xInd <- seq_len(n)
  set.seed(1)
  p <- 3
  data <- cbind(
    MASS::mvrnorm(n, rep(0, p), 
            diag(seq_len(p), nrow=p)),
    rexp(n))

  distM <- dist(data)
  distM2 <- PairwiseDistance(data, Lp)
  distM2p <- PairwiseDistance(data, Lp, PARALLEL=TRUE)
  expect_equal(as.matrix(distM), as.matrix(distM2))
  expect_equal(distM2, distM2p)

})


test_that('PairwiseDistance2 is right', {

  p <- 2
  for (n in c(2, 4, 50)) {
    xInd <- seq_len(n)
    set.seed(1)
    data <- cbind(
      MASS::mvrnorm(n, rep(0, p), 
              diag(seq_len(p), nrow=p)),
      rexp(n))

    # same data
    distM <- dist(data)
    distM2 <- PairwiseDistance2(data, data, Lp)
    distM2p <- PairwiseDistance2(data, data, Lp, PARALLEL=TRUE)
    expect_equal(unname(as.matrix(distM)), as.matrix(distM2))
    expect_equal(distM2, distM2p)

    # different data
    nr <- floor(n / 2)
    subDist <- PairwiseDistance2(data[seq_len(nr), , drop=FALSE], 
                                 data[seq(nr + 1, n), , drop=FALSE], 
                                 Lp)

    expect_equal(subDist, as.matrix(distM2)[seq_len(nr), seq(nr + 1, n), drop=FALSE])
  }

})


test_that('Lp distance is right', {

  n <- 10
  x <- c(0, 0)
  Y <- matrix(rnorm(10), n / 2, 2)
  expect_equal(Lp(x, Y), sqrt(rowSums(Y^2)))
  expect_equal(Lp(x, Y, 10), (rowSums(Y^10))^(1/10))
  expect_true(all(Lp(x, Y, 1) >= Lp(x, Y, 10)))
  
})

test_that('Jiggle() works', {
  scenarios <- list(
    c(n = 4, m = 2), 
    c(n = 6, m = 3), 
    c(n = 8, m = 4), 
    c(n = 20, m = 3))

  for (l in scenarios) {
    n <- unname(l['n'])
    m <- unname(l['m'])

    X <- Jiggle(n, m)

    # Grid points lie on a sphere
    expect_equal(t(apply(X, 1, Normalize)), X)
    expect_equal(nrow(X), n)

    Y <- Jiggle(n, m, 'coordUnif')
    expect_equal(nrow(Y), n)
    if (n == m * 2) {
      expect_equal(apply(Y, 1, function(x) max(abs(x))), rep(1, n))
    }
    # if (m == 3) {
      # print(plotly::plot_ly(x=~Y[, 1], y=~Y[, 2], z=~Y[, 3]))
    # }
  }
})
